"""
Tests to show that SDP components get configuration data from Telescope Model.
In addition, we show that the pointing offset calibration pipeline, executed
in SDP uses an RFI mask (also from Telescope Model).

These test are to demonstrate coverage for
https://jira.skatelescope.org/browse/L2-3829 and
https://jira.skatelescope.org/browse/L2-3832
L2 SDP requirements.

Notes for first Scenario (script definitions):
    - this test assumes the data were loaded into the config db via
    the telescope model as defined in values.yaml: scripts.url
    - if someone is loading custom definitions, this test will fail

Notes for the second Scenario (flagging and telescope layout):
    - these tests are not very robust since they depend on logs appearing
    in the relevant pods; however, they are easy to adjust if needed
    - tests of the processors are available to show that the right
    data from Telescope Model are used correctly; here we only show that
    the processors access the right data from Telescope Model.
    - we do not care whether the pointing pipeline produces results or not;
    we only care that it uses the RFI mask. Therefore, the related test
    is not set to run a full pointing observation. It runs one scan only,
    which will trigger the execution of the pipeline to the point where
    the RFI mask data won't match the processed data generated by vis-receive.
    (Providing the right test data would result in unnecessary increase in
    storage use and run time in the test). Separate tests show the right
    behaviour of the pointing pipeline as part of a pointing observation.
"""

import json
import logging

import pytest
import requests
import yaml
from common.cbf_emulator import send_scans
from common.device_operations import create_id
from common.kubernetes import (
    convert_yaml_file,
    get_pod_logs,
    k8s_pod_exec,
    list_pods,
)
from common.wait import wait_for_predicate
from pytest_bdd import given, scenarios, then, when

LOG = logging.getLogger(__name__)

RFI_TMDATA_SOURCE = (
    "gitlab://gitlab.com/ska-telescope/"
    "ska-telmodel-data?yan-1618-add-rfi-model#tmdata"
)
ANTENNA_LAYOUT_SOURCE = (
    "car://gitlab.com/ska-telescope/ska-telmodel-data?main#tmdata"
)
RFI_MASK_KEY = "instrument/ska1_mid/static-rfi/rfi_mask.h5"
POINTING_SCRIPT_VERSION = "1.0.0"

scenarios("telmodel_flagging.feature")


@pytest.fixture(name="assign_resources_config")
def read_assign_resources_config(telescope_metadata):
    """
    Read the AssignResources config for visibility receive.

    Substitutes randomly-generated IDs so the test can be run more than once in
    the same instance of SDP. The config is used in more than one step in the
    test, so it must be a fixture.
    """
    config = telescope_metadata.assign_resources

    # there should be only one pb in the default string, which is vis-receive
    pblock = config["processing_blocks"][0]
    vis_rec_id = pblock["pb_id"]

    # add pointing processing block
    pointing_pb = {
        "pb_id": create_id("pb"),
        "script": {
            "kind": "realtime",
            "name": "pointing-offset",
            "version": POINTING_SCRIPT_VERSION,
        },
        "parameters": {
            "num_scans": 1,
            "additional_args": [
                "--apply_mask",
            ],
            "telescope_model": {
                "telmodel_sources": [RFI_TMDATA_SOURCE],
                "static_rfi_key": RFI_MASK_KEY,
            },
        },
        "dependencies": [{"pb_id": vis_rec_id, "kind": ["vis-receive"]}],
    }

    config["processing_blocks"].append(pointing_pb)

    return config


# -----------
# Given steps
# -----------

# in integration/conftest.py
# Given I connect to an SDP subarray
# Given obsState is EMPTY
# Given And I select the dataset for the Mid telescope
# Given the volumes are created and the CBF emulator input data is copied
# Given I deploy the visibility receive and pointing offset
#       scripts configured to use telescope model data


@given(
    "the SDP script definitions are available as telescope model data",
    target_fixture="telmodel_script_defs",
)
def script_defs_in_telmodel():
    """
    Load script definitions from telescope model data.
    """
    sdp_values_file = "charts/ska-sdp/values.yaml"
    script_def_gitlab_file = "tmdata/ska-sdp/scripts/scripts.yaml"

    values_data = convert_yaml_file(sdp_values_file)
    script_def_source = values_data["scripts"]["url"]
    script_def_url = script_def_source.replace(
        "tmdata::gitlab", "https"
    ).replace("#tmdata", f"/-/raw/master/{script_def_gitlab_file}")

    response = requests.get(script_def_url, timeout=60)
    telmodel_script_data = yaml.safe_load(response.content.decode("utf-8"))

    assert telmodel_script_data is not None
    telmodel_script_data = telmodel_script_data["scripts"]

    for data in telmodel_script_data:
        # remove schema information;
        # this is not stored in the config db directly
        if "schema" in data:
            del data["schema"]

    return telmodel_script_data


@given(
    "telescope model data for telescope layout "
    "and static RFI mask are available",
    target_fixture="telmodel_antenna_data",
)
def telmodel_data_present(telescope_metadata):
    """
    Load antenna layout data directly from Telescope Model.
    This will be compared with the data logged inside the
    receiver (vis-receive container).
    """
    url_base = ANTENNA_LAYOUT_SOURCE.replace("car", "https").replace(
        "?main#tmdata", "/-/raw/main/tmdata"
    )
    url = f"{url_base}/{telescope_metadata.telescope_model['telmodel_key']}"

    data = requests.get(url, timeout=60).json()
    ant_data = [
        datum
        for datum in data["receptors"]
        if datum["station_label"] in telescope_metadata.receptors
    ]

    # make sure data for the receptors were found
    assert len(ant_data) == len(telescope_metadata.receptors)

    return ant_data


# ----------
# When steps
# ----------

SCRIPT_PYTHON_CODE = """
from ska_sdp_config import Config

script_data = []
for txn in Config().txn():
    for script_key, script_value in txn.script.query_values():
        script_data.append({
            "kind": script_key.kind,
            "name": script_key.name,
            "version": script_key.version,
            "image": script_value.image,
            "sdp_version": script_value.sdp_version or ""
        })

print(script_data)
"""


@when(
    "I read the script definitions from the configuration database",
    target_fixture="configdb_script_defs",
)
def script_defs_in_configdb(context):
    """
    Load script definitions from the configuration db via the console pod.
    """
    cmd = ["python", "-c", SCRIPT_PYTHON_CODE]
    data_str = ""

    response = k8s_pod_exec(
        cmd, "ska-sdp-console-0", "console", context.sdp.namespace, stdin=False
    )
    while response.is_open():
        response.update(timeout=1)
        if response.peek_stdout():
            data_str = response.read_stdout().strip()
    response.close()

    script_data = json.loads(data_str.replace("'", '"'))
    return script_data


@when(
    "SDP is commanded to capture data for pointing scans",
    target_fixture="log_data",
)
# pylint: disable-next=too-many-arguments,too-many-positional-arguments
def command_scans(
    context,
    subarray_device,
    subarray_ready,
    k8s_element_manager,
    telescope_metadata,
    assign_resources_config,
):
    """
    Run one scan and return the relevant logs from the
    pointing-offset and vis-receive pods (i.e. pointing
    calibration pipeline and receiver containers).

    :param context: context for the tests
    :param subarray_device: SDP subarray device client
    :param subarray_ready: subarray fixture
    :param k8s_element_manager: Kubernetes element manager
    :param telescope_metadata: fixture for storing and managing metadata
    :param assign_resources_config: configuration string for AssignResources
    """
    visrec_pb_id = assign_resources_config["processing_blocks"][0]["pb_id"]
    pointing_pb_id = assign_resources_config["processing_blocks"][1]["pb_id"]

    def _get_logs():
        pods = list_pods(context.sdp.namespace_sdp)
        pointing_pod = [
            pod.metadata.name
            for pod in pods.items
            if f"{pointing_pb_id}-pointing-offset" in pod.metadata.name
        ][0]

        pointing_logs = get_pod_logs(pointing_pod, context.sdp.namespace_sdp)

        if pointing_logs and "Static RFI mask downloaded" in pointing_logs:
            # at this point we can also check what the receiver was doing;
            # relevant telmodel logs appear there much sooner than in pointing
            receive_pod = [
                pod.metadata.name
                for pod in pods.items
                if f"{visrec_pb_id}-vis-receive" in pod.metadata.name
            ][0]
            receive_logs = get_pod_logs(
                receive_pod, context.sdp.namespace_sdp, container="receiver-00"
            )
            # make sure receive is loading the data from
            # where we think it's loading
            assert ANTENNA_LAYOUT_SOURCE in receive_logs
            # in logs, the following sentence starts the log of telmodel data
            telmodel_info_start = receive_logs.find(
                "Build SKATelescopeModel with"
            )
            # we return everything that is logged within this line,
            # so search until linebreak
            telmodel_info_end = receive_logs.find(
                "\n", receive_logs.find("Build SKATelescopeModel with")
            )
            telmodel_info = receive_logs[telmodel_info_start:telmodel_info_end]

            return pointing_logs, telmodel_info
        return None

    def _wait_for_logs():
        return wait_for_predicate(
            _get_logs, "Obtaining Telescope Model related logs"
        )

    ms_data = telescope_metadata.data_dir[0]
    commanded_scans = [(1, "pointing", ms_data)]

    return send_scans(
        context,
        subarray_device,
        subarray_ready,
        k8s_element_manager,
        telescope_metadata,
        commanded_scans,
        before_end_callback=_wait_for_logs,
    )


# ----------
# Then steps
# ----------


@then("the script definitions from the two sources are the same")
def tmp(configdb_script_defs, telmodel_script_defs):
    """Compare script definitions loaded from telmodel and config db."""
    assert sorted(configdb_script_defs, key=lambda d: d["image"]) == sorted(
        telmodel_script_defs, key=lambda d: d["image"]
    )


@then(
    "the receiver is using the Mid layout configuration from telescope model"
)
def mid_layout_check(log_data, telmodel_antenna_data, telescope_metadata):
    """Compare log data with data obtained directly from Telescope Model."""

    receive_logs = log_data[1]

    receptors = telescope_metadata.receptors
    expected_antenna_names_text = [
        f"station_label='{receptor}'" for receptor in receptors
    ]
    expected_antenna_coordinates_text = [
        json.dumps(telmodel_antenna_data[i]["location"]["geodetic"]).replace(
            '"', "'"
        )
        for i in range(len(receptors))
    ]

    for text in expected_antenna_names_text:
        assert text in receive_logs
    for text in expected_antenna_coordinates_text:
        assert text in receive_logs


@then(
    "the pointing offset calibration pipeline is "
    "using the RFI mask from telescope model"
)
def rfi_mask_check(log_data):
    """
    Log data of the pointing calibration pipeline indicates that
    the pipeline is using the RFI mask from Telescope Model.
    """
    pointing_logs = log_data[0]
    assert "Pulling static RFI mask from telmodel store..." in pointing_logs
    assert "Static RFI mask downloaded" in pointing_logs
    assert f"{RFI_TMDATA_SOURCE}: Loading GitLab tarball..." in pointing_logs
